package com.sxtvs.open.api.news.entity;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import jakarta.annotation.Resource;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.HashMap;
import java.util.Map;

@EqualsAndHashCode(callSuper = true)
@Data
public class YoumeiEsData extends YoumeiData{


    private Map<String, Object> raw;

    public YoumeiEsData() {

    }

    public static YoumeiEsData of(YoumeiData youmeiData){
        YoumeiEsData data = new YoumeiEsData();
        data.setAuthor(youmeiData.getAuthor());
        data.setContent(youmeiData.getContent());
        data.setContentId(youmeiData.getContentId());
        data.setObjType(youmeiData.getObjType());
        data.setOffset(youmeiData.getOffset());
        data.setPublishTime(youmeiData.getPublishTime());
        data.setSourceUrl(youmeiData.getSourceUrl());
        data.setSourceWebsite(youmeiData.getSourceWebsite());
        data.setRaw(youmeiData.getRawData());
        return data;
    }

    public void setRaw(String rawData) {
        Map<String, Object> map = new HashMap<>();
        try {
            ObjectMapper objectMapper = new ObjectMapper();
            map = objectMapper.readValue(rawData, new TypeReference<>() {});
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
        this.raw = (Map<String, Object>) map.get("data");
    }

    public Map<String, Object> getRaw() {
        return this.raw;
    }
}
